program Interferer;

uses Windows, Graphics, messages, math, sysutils;

const N=57; //   

type
  trgb = record
   b,g,r: byte;
  end;
  ARGB = array [0..0] of TRGB;
  PARGB = ^ARGB;

  expoint = record
   X,Y:extended;
  end;

var wc:TWndClassEx;
    MainWnd:THandle;
    Mesg:TMsg;
    b:tbitmap;
    pb:array of PARGB;
    i:integer;
    tR:trect;
    Thr: LongWord;

procedure bres_circle(xc,yc,radius:integer; r,g,b:byte); // Bresenham's (Pitteway and van Aken) algorithm
 var a,c,d:integer;
 procedure sim(x,y:integer; r,g,b:byte);
  var i,j:integer;
 begin
  i:=xc+x;
  j:=yc+y;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
  j:=yc-y;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
  i:=xc-x;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
  j:=yc+y;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
  i:=xc+y;
  j:=yc+x;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
  j:=yc-x;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
  i:=xc-y;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
  i:=xc-y;
  j:=yc+x;
  pb[j,i].r:=r; pb[j,i].g:=g; pb[j,i].b:=b;
 end;
begin
 a:=0;
 c:=radius;
 d:=3-2*c;
 while(a<=c) do begin
  sim(a,c,r,g,b);
  if d<0 then d:=d+4*a+8
  else begin
   d:=d+4*(a-c)+10;
   dec(c);
  end;
  inc(a)
 end;
end;

function Point2Ang(x,y,CentrX,CentrY,R:extended):extended; // -    Y    12:00    0-359
 var dx,dy:extended;
begin
 if R<>0 then begin
  dx:=x-CentrX;
  dy:=y-CentrY;
  if dx<0 then
   if dy<0 then result:=360+180*arcsin(dx/R)/pi
           else result:=180-180*arcsin(dx/R)/pi
  else
   if dy<0 then result:=180*arcsin(dx/R)/pi
           else result:=180-180*arcsin(dx/R)/pi;
 end else result:=0;
end;

function Ang2Point(angle,R:extended):expoint;// 0-359,   12:00   ,  -      R   (0,0)
 var z:integer;
begin
 z:=trunc(angle/180);
 case z of
 0:begin
   result.X:=r*sin(pi*angle/180);
   result.Y:=r*-cos(pi*angle/180);
  end;
 1:begin
   angle:=angle-180*z;
   result.X:=r*-sin(pi*angle/180);
   result.Y:=r*cos(pi*angle/180);
  end;
 end;
end;

function Doedin(x:extended):integer; //,  
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

procedure CalcProc;
 var i,j,k,l,ind1,ind2,res1,res2:integer;
     dc:hdc;
     ug,ug1,ug2,R,centrX,centrY,d:extended;
     points:array of expoint; //    
     ugols1,ugols2:array of extended; //   
begin
 R:=b.Height/2-1; //     
 centrX:=b.Width/2; //    
 centrY:=b.Height/2;
 setlength(points,n);
 ug:=360/n; //    
 for i:=0 to n-1 do points[i]:=Ang2Point(ug*i,R);

 ind1:=doedin(n/2+n/9); //  
 ind2:=doedin(n/2-n/9);
 setlength(ugols1,n); //     
 setlength(ugols2,n);

 ugols1[0]:=270;//      
 j:=1;
 for i:=ind1+1 to n-1 do begin
  d:=sqrt((points[ind1].X-points[i].X)*(points[ind1].X-points[i].X)+(points[ind1].Y-points[i].Y)*(points[ind1].Y-points[i].Y));
  ugols1[j]:=Point2Ang(points[i].X,points[i].Y,points[ind1].X,points[ind1].Y,d);
  j:=j+1;
 end;
 for i:=0 to ind1-1 do begin
  d:=sqrt((points[ind1].X-points[i].X)*(points[ind1].X-points[i].X)+(points[ind1].Y-points[i].Y)*(points[ind1].Y-points[i].Y));
  ugols1[j]:=Point2Ang(points[i].X,points[i].Y,points[ind1].X,points[ind1].Y,d);
  j:=j+1;
 end;

 ugols2[0]:=90;//      
 j:=1;
 for i:=ind2+1 to n-1 do begin
  d:=sqrt((points[ind2].X-points[i].X)*(points[ind2].X-points[i].X)+(points[ind2].Y-points[i].Y)*(points[ind2].Y-points[i].Y));
  ugols2[j]:=Point2Ang(points[i].X,points[i].Y,points[ind2].X,points[ind2].Y,d);
  j:=j+1;
 end;
 for i:=0 to ind2-1 do begin
  d:=sqrt((points[ind2].X-points[i].X)*(points[ind2].X-points[i].X)+(points[ind2].Y-points[i].Y)*(points[ind2].Y-points[i].Y));
  ugols2[j]:=Point2Ang(points[i].X,points[i].Y,points[ind2].X,points[ind2].Y,d);
  j:=j+1;
 end;
 
 for i:=0 to n-1 do begin
  j:=doedin(points[i].Y+centrY);
  k:=doedin(points[i].X+centrX);
  if (i=ind1) or (i=ind2) then begin
   pb[j,k].r:=255;
   pb[j,k].g:=0;
   pb[j,k].b:=0;
  end else begin
   pb[j,k].r:=255;
   pb[j,k].g:=255;
   pb[j,k].b:=255;
  end;
 end;

 bres_circle(doedin(centrX),doedin(centrY),doedin(R),255,255,255);

 for i:=0 to b.Width-1 do
  for j:=0 to b.Height-1 do begin
   d:=sqrt((centrX-i)*(centrX-i)+(centrY-j)*(centrY-j));//     
   if d<R then begin

   d:=sqrt((points[ind1].X+centrX-i)*(points[ind1].X+centrX-i)+(points[ind1].Y+centrY-j)*(points[ind1].Y+centrY-j));
   ug1:=Point2Ang(i,j,points[ind1].X+centrX,points[ind1].Y+centrY,d);
   d:=sqrt((points[ind2].X+centrX-i)*(points[ind2].X+centrX-i)+(points[ind2].Y+centrY-j)*(points[ind2].Y+centrY-j));
   ug2:=Point2Ang(i,j,points[ind2].X+centrX,points[ind2].Y+centrY,d);

   res1:=0;
   for k:=0 to n do begin
    if ugols1[k+1]>ugols1[k] then begin   //  
     if (ug1>=ugols1[k])and(ug1<ugols1[k+1]) then begin
      res1:=k;
      break;
     end;
    end else begin    // ,     360-0
     if ((ug1>=ugols1[k])and(ug1<360))or((ug1>=0)and(ug1<ugols1[k+1])) then begin
      res1:=k;
      break;
     end;
    end;
   end;

   res2:=0;
   for l:=0 to n do begin
    if ugols2[l+1]>ugols2[l] then begin   //  
     if (ug2>=ugols2[l])and(ug2<ugols2[l+1]) then begin
      res2:=l;
      break;
     end;
    end else begin    // ,     360-0
     if ((ug2>=ugols2[l])and(ug2<360))or((ug2>=0)and(ug2<ugols2[l+1])) then begin
      res2:=l;
      break;
     end;
    end;
   end;

   if (ug1<90)or(ug1>180) then begin
    if odd(res1)<>odd(res2) then begin
     pb[j,i].r:=255;
     pb[j,i].g:=255;
     pb[j,i].b:=255;
    end;
   end else begin
    if odd(res1)=odd(res2) then begin
     pb[j,i].r:=255;
     pb[j,i].g:=255;
     pb[j,i].b:=255;
    end;
   end;

   end;
  end;

  postmessage(MainWnd,wm_paint,0,0);
end;

function WindowProc(wnd:HWND; Msg:Integer; Wparam:Wparam; Lparam:Lparam): Longint; stdcall;
 var dc:hdc;
begin
 Result:=0;
 case msg of
 wm_keydown: postmessage(MainWnd,wm_destroy,0,0);
 wm_lbuttondown: postmessage(MainWnd,wm_destroy,0,0);
 wm_paint: begin
  dc:=getdc(MainWnd);
  bitblt(dc,0,0,b.Width,b.Height,b.Canvas.Handle,0,0,srccopy);
  ReleaseDC(MainWnd,dc);
 end;

 wm_destroy: begin
  b.Free;
  invalidaterect(0,nil,false);
  unregisterclass('Interferer',hinstance);
  postquitmessage(0);
 end;
 else Result:=DefWindowProc(wnd,msg,wparam,lparam);end;
end;

BEGIN
 b:=tbitmap.Create;
 b.PixelFormat:=pf24bit;
 b.Width:=GetSystemMetrics(SM_CXSCREEN);
 b.Height:=GetSystemMetrics(SM_CYSCREEN);

 setlength(pb,b.Height);
 for i:=0 to b.Height-1 do pb[i]:=b.scanline[i];
 b.Canvas.Brush.Color:=clblack;
 tr:=b.Canvas.ClipRect;
 b.Canvas.FillRect(tR);

 wc.cbSize:=sizeof(wc);
 wc.lpfnWndProc:=@WindowProc;
 wc.hCursor:=LoadCursor(0,idc_arrow);
 WC.hbrBackground:=5;
 wc.lpszClassName:='Interferer';
 RegisterClassEx(wc);
 MainWnd:=CreateWindowEx(WS_EX_TOOLWINDOW,'Interferer','',0,0,0,b.Width,b.Height,0,0,Hinstance,nil);
 SetWindowLong(MainWnd,GWL_STYLE,GetWindowLong(MainWnd,GWL_STYLE) and (not WS_CAPTION));  //   
 ShowWindow(MainWnd,SW_SHOWMAXIMIZED);

 CreateThread(nil,0,@CalcProc,nil,0,Thr);

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;
END.
